Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/DIA/diahth.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/DIA/diahth.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/DIA/diahth.F90	(revision 12928)
@@ -37,299 +50,320 @@
 CONTAINS
 
-
-   SUBROUTINE dia_hth( kt )
-     !!---------------------------------------------------------------------
-     !!                  ***  ROUTINE dia_hth  ***
-     !!
-     !! ** Purpose : Computes
-     !!      the mixing layer depth (turbocline): avt = 5.e-4
-     !!      the depth of strongest vertical temperature gradient
-     !!      the mixed layer depth with density     criteria: rho = rho(10m or surf) + 0.03(or 0.01)
-     !!      the mixed layer depth with temperature criteria: abs( tn - tn(10m) ) = 0.2
-     !!      the top of the thermochine: tn = tn(10m) - ztem2
-     !!      the pycnocline depth with density criteria equivalent to a temperature variation
-     !!                rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC)
-     !!      the barrier layer thickness
-     !!      the maximal verical inversion of temperature and its depth max( 0, max of tn - tn(10m) )
-     !!      the depth of the 20 degree isotherm (linear interpolation)
-     !!      the depth of the 28 degree isotherm (linear interpolation)
-     !!      the heat content of first 300 m
-     !!
-     !! ** Method :
-     !!-------------------------------------------------------------------
-     INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-     !!
-     INTEGER                          ::   ji, jj, jk            ! dummy loop arguments
-     INTEGER                          ::   iid, ilevel           ! temporary integers
-     INTEGER, DIMENSION(jpi,jpj) ::   ik20, ik28  ! levels
-     REAL(wp)                         ::   zavt5 = 5.e-4_wp      ! Kz criterion for the turbocline depth
-     REAL(wp)                         ::   zrho3 = 0.03_wp       ! density     criterion for mixed layer depth
-     REAL(wp)                         ::   zrho1 = 0.01_wp       ! density     criterion for mixed layer depth
-     REAL(wp)                         ::   ztem2 = 0.2_wp        ! temperature criterion for mixed layer depth
-     REAL(wp)                         ::   zthick_0, zcoef       ! temporary scalars
-     REAL(wp)                         ::   zztmp, zzdep          ! temporary scalars inside do loop
-     REAL(wp)                         ::   zu, zv, zw, zut, zvt  ! temporary workspace
-     REAL(wp), DIMENSION(jpi,jpj) ::   zabs2      ! MLD: abs( tn - tn(10m) ) = ztem2
-     REAL(wp), DIMENSION(jpi,jpj) ::   ztm2       ! Top of thermocline: tn = tn(10m) - ztem2
-     REAL(wp), DIMENSION(jpi,jpj) ::   zrho10_3   ! MLD: rho = rho10m + zrho3
-     REAL(wp), DIMENSION(jpi,jpj) ::   zpycn      ! pycnocline: rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC)
-     REAL(wp), DIMENSION(jpi,jpj) ::   ztinv      ! max of temperature inversion
-     REAL(wp), DIMENSION(jpi,jpj) ::   zdepinv    ! depth of temperature inversion
-     REAL(wp), DIMENSION(jpi,jpj) ::   zrho0_3    ! MLD rho = rho(surf) = 0.03
-     REAL(wp), DIMENSION(jpi,jpj) ::   zrho0_1    ! MLD rho = rho(surf) = 0.01
-     REAL(wp), DIMENSION(jpi,jpj) ::   zmaxdzT    ! max of dT/dz
-     REAL(wp), DIMENSION(jpi,jpj) ::   zthick     ! vertical integration thickness
-     REAL(wp), DIMENSION(jpi,jpj) ::   zdelr      ! delta rho equivalent to deltaT = 0.2
-   ! note: following variables should move to local variables once iom_put is always used
-     REAL(wp), DIMENSION(jpi,jpj) ::   zhth    !: depth of the max vertical temperature gradient [m]
-     REAL(wp), DIMENSION(jpi,jpj) ::   zhd20   !: depth of 20 C isotherm                         [m]
-     REAL(wp), DIMENSION(jpi,jpj) ::   zhd28   !: depth of 28 C isotherm                         [m]
-     REAL(wp), DIMENSION(jpi,jpj) ::   zhtc3   !: heat content of first 300 m                    [W]
-
-     IF (iom_use("mlddzt") .OR. iom_use("mldr0_3") .OR. iom_use("mldr0_1")) THEN
-        ! ------------------------------------------------------------- !
-        ! thermocline depth: strongest vertical gradient of temperature !
-        ! turbocline depth (mixing layer depth): avt = zavt5            !
-        ! MLD: rho = rho(1) + zrho3                                     !
-        ! MLD: rho = rho(1) + zrho1                                     !
-        ! ------------------------------------------------------------- !
-        zmaxdzT(:,:) = 0._wp
-        IF( nla10 > 1 ) THEN
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 zztmp = gdepw_n(ji,jj,mbkt(ji,jj)+1)
-                 zrho0_3(ji,jj) = zztmp
-                 zrho0_1(ji,jj) = zztmp
-                 zhth(ji,jj) = zztmp
-              END DO
-           END DO
-        ELSE IF (iom_use("mlddzt")) THEN
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 zztmp = gdepw_n(ji,jj,mbkt(ji,jj)+1)
-                 zhth(ji,jj) = zztmp
-              END DO
-           END DO
-        ELSE
-           zhth(:,:) = 0._wp
-
-        ENDIF
-
-        DO jk = jpkm1, 2, -1   ! loop from bottom to 2
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 !
-                 zzdep = gdepw_n(ji,jj,jk)
-                 zztmp = ( tsn(ji,jj,jk-1,jp_tem) - tsn(ji,jj,jk,jp_tem) ) / zzdep * tmask(ji,jj,jk)   ! vertical gradient of temperature (dT/dz)
-                 zzdep = zzdep * tmask(ji,jj,1)
-
-                 IF( zztmp > zmaxdzT(ji,jj) ) THEN
-                    zmaxdzT(ji,jj) = zztmp   ;   zhth    (ji,jj) = zzdep                ! max and depth of dT/dz
-                 ENDIF
-
-                 IF( nla10 > 1 ) THEN
-                    zztmp = rhop(ji,jj,jk) - rhop(ji,jj,1)                             ! delta rho(1)
-                    IF( zztmp > zrho3 )          zrho0_3(ji,jj) = zzdep                ! > 0.03
-                    IF( zztmp > zrho1 )          zrho0_1(ji,jj) = zzdep                ! > 0.01
-                 ENDIF
-
-              END DO
-           END DO
-        END DO
-
-        IF (iom_use("mlddzt")) CALL iom_put( "mlddzt", zhth*tmask(:,:,1) )            ! depth of the thermocline
-        IF( nla10 > 1 ) THEN
-           IF (iom_use("mldr0_3")) CALL iom_put( "mldr0_3", zrho0_3*tmask(:,:,1) )   ! MLD delta rho(surf) = 0.03
-           IF (iom_use("mldr0_1")) CALL iom_put( "mldr0_1", zrho0_1*tmask(:,:,1) )   ! MLD delta rho(surf) = 0.01
-        ENDIF
+   FUNCTION dia_hth_alloc()
+      !!---------------------------------------------------------------------
+      INTEGER :: dia_hth_alloc
+      !!---------------------------------------------------------------------
+      !
+      ALLOCATE( hth(jpi,jpj), hd20(jpi,jpj), hd26(jpi,jpj), hd28(jpi,jpj), &
+         &      htc3(jpi,jpj), htc7(jpi,jpj), htc20(jpi,jpj), STAT=dia_hth_alloc )
+      !
+      CALL mpp_sum ( 'diahth', dia_hth_alloc )
+      IF(dia_hth_alloc /= 0)   CALL ctl_stop( 'STOP', 'dia_hth_alloc: failed to allocate arrays.' )
+      !
+   END FUNCTION dia_hth_alloc
+
+   SUBROUTINE dia_hth( kt, Kmm )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE dia_hth  ***
+      !!
+      !! ** Purpose : Computes
+      !!      the mixing layer depth (turbocline): avt = 5.e-4
+      !!      the depth of strongest vertical temperature gradient
+      !!      the mixed layer depth with density     criteria: rho = rho(10m or surf) + 0.03(or 0.01)
+      !!      the mixed layer depth with temperature criteria: abs( tn - tn(10m) ) = 0.2       
+      !!      the top of the thermochine: tn = tn(10m) - ztem2 
+      !!      the pycnocline depth with density criteria equivalent to a temperature variation 
+      !!                rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC) 
+      !!      the barrier layer thickness
+      !!      the maximal verical inversion of temperature and its depth max( 0, max of tn - tn(10m) )
+      !!      the depth of the 20 degree isotherm (linear interpolation)
+      !!      the depth of the 28 degree isotherm (linear interpolation)
+      !!      the heat content of first 300 m
+      !!
+      !! ** Method : 
+      !!-------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      INTEGER, INTENT( in ) ::   Kmm     ! ocean time level index
+      !!
+      INTEGER                      ::   ji, jj, jk            ! dummy loop arguments
+      REAL(wp)                     ::   zrho3 = 0.03_wp       ! density     criterion for mixed layer depth
+      REAL(wp)                     ::   zrho1 = 0.01_wp       ! density     criterion for mixed layer depth
+      REAL(wp)                     ::   ztem2 = 0.2_wp        ! temperature criterion for mixed layer depth
+      REAL(wp)                     ::   zztmp, zzdep          ! temporary scalars inside do loop
+      REAL(wp)                     ::   zu, zv, zw, zut, zvt  ! temporary workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   zabs2      ! MLD: abs( tn - tn(10m) ) = ztem2 
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztm2       ! Top of thermocline: tn = tn(10m) - ztem2     
+      REAL(wp), DIMENSION(jpi,jpj) ::   zrho10_3   ! MLD: rho = rho10m + zrho3      
+      REAL(wp), DIMENSION(jpi,jpj) ::   zpycn      ! pycnocline: rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC)
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztinv      ! max of temperature inversion
+      REAL(wp), DIMENSION(jpi,jpj) ::   zdepinv    ! depth of temperature inversion
+      REAL(wp), DIMENSION(jpi,jpj) ::   zrho0_3    ! MLD rho = rho(surf) = 0.03
+      REAL(wp), DIMENSION(jpi,jpj) ::   zrho0_1    ! MLD rho = rho(surf) = 0.01
+      REAL(wp), DIMENSION(jpi,jpj) ::   zmaxdzT    ! max of dT/dz
+      REAL(wp), DIMENSION(jpi,jpj) ::   zdelr      ! delta rho equivalent to deltaT = 0.2
+      !!----------------------------------------------------------------------
+      IF( ln_timing )   CALL timing_start('dia_hth')
+
+      IF( kt == nit000 ) THEN
+         l_hth = .FALSE.
+         IF(   iom_use( 'mlddzt'   ) .OR. iom_use( 'mldr0_3'  ) .OR. iom_use( 'mldr0_1'  )    .OR.  & 
+            &  iom_use( 'mld_dt02' ) .OR. iom_use( 'topthdep' ) .OR. iom_use( 'mldr10_3' )    .OR.  &    
+            &  iom_use( '20d'      ) .OR. iom_use( '26d'      ) .OR. iom_use( '28d'      )    .OR.  &    
+            &  iom_use( 'hc300'    ) .OR. iom_use( 'hc700'    ) .OR. iom_use( 'hc2000'   )    .OR.  &    
+            &  iom_use( 'pycndep'  ) .OR. iom_use( 'tinv'     ) .OR. iom_use( 'depti'    )  ) l_hth = .TRUE.
+         !                                      ! allocate dia_hth array
+         IF( l_hth ) THEN 
+            IF( dia_hth_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'dia_hth : unable to allocate standard arrays' )
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'dia_hth : diagnostics of the thermocline depth'
+            IF(lwp) WRITE(numout,*) '~~~~~~~ '
+            IF(lwp) WRITE(numout,*)
+         ENDIF
+      ENDIF
+
+      IF( l_hth ) THEN
+         !
+         IF( iom_use( 'mlddzt' ) .OR. iom_use( 'mldr0_3' ) .OR. iom_use( 'mldr0_1' ) ) THEN
+            ! initialization
+            ztinv  (:,:) = 0._wp  
+            zdepinv(:,:) = 0._wp  
+            zmaxdzT(:,:) = 0._wp  
+            DO_2D_11_11
+               zztmp = gdepw(ji,jj,mbkt(ji,jj)+1,Kmm) 
+               hth     (ji,jj) = zztmp
+               zabs2   (ji,jj) = zztmp
+               ztm2    (ji,jj) = zztmp
+               zrho10_3(ji,jj) = zztmp
+               zpycn   (ji,jj) = zztmp
+            END_2D
+            IF( nla10 > 1 ) THEN 
+               DO_2D_11_11
+                  zztmp = gdepw(ji,jj,mbkt(ji,jj)+1,Kmm) 
+                  zrho0_3(ji,jj) = zztmp
+                  zrho0_1(ji,jj) = zztmp
+               END_2D
+            ENDIF
+      
+            ! Preliminary computation
+            ! computation of zdelr = (dr/dT)(T,S,10m)*(-0.2 degC)
+            DO_2D_11_11
+               IF( tmask(ji,jj,nla10) == 1. ) THEN
+                  zu  =  1779.50 + 11.250 * ts(ji,jj,nla10,jp_tem,Kmm) - 3.80   * ts(ji,jj,nla10,jp_sal,Kmm)  &
+                     &           - 0.0745 * ts(ji,jj,nla10,jp_tem,Kmm) * ts(ji,jj,nla10,jp_tem,Kmm)   &
+                     &           - 0.0100 * ts(ji,jj,nla10,jp_tem,Kmm) * ts(ji,jj,nla10,jp_sal,Kmm)
+                  zv  =  5891.00 + 38.000 * ts(ji,jj,nla10,jp_tem,Kmm) + 3.00   * ts(ji,jj,nla10,jp_sal,Kmm)  &
+                     &           - 0.3750 * ts(ji,jj,nla10,jp_tem,Kmm) * ts(ji,jj,nla10,jp_tem,Kmm)
+                  zut =    11.25 -  0.149 * ts(ji,jj,nla10,jp_tem,Kmm) - 0.01   * ts(ji,jj,nla10,jp_sal,Kmm)
+                  zvt =    38.00 -  0.750 * ts(ji,jj,nla10,jp_tem,Kmm)
+                  zw  = (zu + 0.698*zv) * (zu + 0.698*zv)
+                  zdelr(ji,jj) = ztem2 * (1000.*(zut*zv - zvt*zu)/zw)
+               ELSE
+                  zdelr(ji,jj) = 0._wp
+               ENDIF
+            END_2D
+
+            ! ------------------------------------------------------------- !
+            ! thermocline depth: strongest vertical gradient of temperature !
+            ! turbocline depth (mixing layer depth): avt = zavt5            !
+            ! MLD: rho = rho(1) + zrho3                                     !
+            ! MLD: rho = rho(1) + zrho1                                     !
+            ! ------------------------------------------------------------- !
+            DO_3DS_11_11( jpkm1, 2, -1 )
+               !
+               zzdep = gdepw(ji,jj,jk,Kmm)
+               zztmp = ( ts(ji,jj,jk-1,jp_tem,Kmm) - ts(ji,jj,jk,jp_tem,Kmm) ) &
+                      & / zzdep * tmask(ji,jj,jk)   ! vertical gradient of temperature (dT/dz)
+               zzdep = zzdep * tmask(ji,jj,1)
+
+               IF( zztmp > zmaxdzT(ji,jj) ) THEN                        
+                   zmaxdzT(ji,jj) = zztmp   
+                   hth    (ji,jj) = zzdep                ! max and depth of dT/dz
+               ENDIF
+         
+               IF( nla10 > 1 ) THEN 
+                  zztmp = rhop(ji,jj,jk) - rhop(ji,jj,1)                       ! delta rho(1)
+                  IF( zztmp > zrho3 )   zrho0_3(ji,jj) = zzdep                ! > 0.03
+                  IF( zztmp > zrho1 )   zrho0_1(ji,jj) = zzdep                ! > 0.01
+               ENDIF
+            END_3D
+         
+            CALL iom_put( 'mlddzt', hth*tmask(:,:,1) )            ! depth of the thermocline
+            IF( nla10 > 1 ) THEN 
+               CALL iom_put( 'mldr0_3', zrho0_3*tmask(:,:,1) )   ! MLD delta rho(surf) = 0.03
+               CALL iom_put( 'mldr0_1', zrho0_1*tmask(:,:,1) )   ! MLD delta rho(surf) = 0.01
+            ENDIF
+            !
+         ENDIF
+         !
+         IF(  iom_use( 'mld_dt02' ) .OR. iom_use( 'topthdep' ) .OR. iom_use( 'mldr10_3' ) .OR.  &    
+            &  iom_use( 'pycndep' ) .OR. iom_use( 'tinv'     ) .OR. iom_use( 'depti'    )  ) THEN
+            ! ------------------------------------------------------------- !
+            ! MLD: abs( tn - tn(10m) ) = ztem2                              !
+            ! Top of thermocline: tn = tn(10m) - ztem2                      !
+            ! MLD: rho = rho10m + zrho3                                     !
+            ! pycnocline: rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC)       !
+            ! temperature inversion: max( 0, max of tn - tn(10m) )          !
+            ! depth of temperature inversion                                !
+            ! ------------------------------------------------------------- !
+            DO_3DS_11_11( jpkm1, nlb10, -1 )
+               !
+               zzdep = gdepw(ji,jj,jk,Kmm) * tmask(ji,jj,1)
+               !
+               zztmp = ts(ji,jj,nla10,jp_tem,Kmm) - ts(ji,jj,jk,jp_tem,Kmm)  ! - delta T(10m)
+               IF( ABS(zztmp) > ztem2 )      zabs2   (ji,jj) = zzdep   ! abs > 0.2
+               IF(     zztmp  > ztem2 )      ztm2    (ji,jj) = zzdep   ! > 0.2
+               zztmp = -zztmp                                          ! delta T(10m)
+               IF( zztmp >  ztinv(ji,jj) ) THEN                        ! temperature inversion
+                  ztinv(ji,jj) = zztmp   
+                  zdepinv (ji,jj) = zzdep   ! max value and depth
+               ENDIF
+
+               zztmp = rhop(ji,jj,jk) - rhop(ji,jj,nla10)              ! delta rho(10m)
+               IF( zztmp > zrho3        )    zrho10_3(ji,jj) = zzdep   ! > 0.03
+               IF( zztmp > zdelr(ji,jj) )    zpycn   (ji,jj) = zzdep   ! > equi. delta T(10m) - 0.2
+               !
+            END_3D
+
+        CALL iom_put( "mld_dt02", zabs2*tmask(:,:,1)        )   ! MLD abs(delta t) - 0.2
+        CALL iom_put( "topthdep", ztm2*tmask(:,:,1)         )   ! T(10) - 0.2
+        CALL iom_put( "mldr10_3", zrho10_3*tmask(:,:,1)     )   ! MLD delta rho(10m) = 0.03
+        CALL iom_put( "pycndep" , zpycn*tmask(:,:,1)        )   ! MLD delta rho equi. delta T(10m) = 0.2
+        CALL iom_put( "tinv"    , ztinv*tmask(:,:,1)        )   ! max. temp. inv. (t10 ref)
+        CALL iom_put( "depti"   , zdepinv*tmask(:,:,1)      )   ! depth of max. temp. inv. (t10 ref)
      ENDIF
-
-     IF (iom_use("mld_dt02") .OR. iom_use("topthdep") .OR. iom_use("mldr10_3") .OR.  &
-          & iom_use("pycndep") .OR. iom_use("tinv") .OR. iom_use("depti")) THEN
-        DO jj = 1, jpj
-           DO ji = 1, jpi
-              zztmp = gdepw_n(ji,jj,mbkt(ji,jj)+1)
-              zabs2   (ji,jj) = zztmp
-              ztm2    (ji,jj) = zztmp
-              zrho10_3(ji,jj) = zztmp
-              zpycn   (ji,jj) = zztmp
-           END DO
-        END DO
-        ztinv  (:,:) = 0._wp
-        zdepinv(:,:) = 0._wp
-
-        IF (iom_use("pycndep")) THEN
-           ! Preliminary computation
-           ! computation of zdelr = (dr/dT)(T,S,10m)*(-0.2 degC)
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 IF( tmask(ji,jj,nla10) == 1. ) THEN
-                    zu  =  1779.50 + 11.250 * tsn(ji,jj,nla10,jp_tem) - 3.80   * tsn(ji,jj,nla10,jp_sal)                             &
-                         &                                              - 0.0745 * tsn(ji,jj,nla10,jp_tem) * tsn(ji,jj,nla10,jp_tem)   &
-                         &                                              - 0.0100 * tsn(ji,jj,nla10,jp_tem) * tsn(ji,jj,nla10,jp_sal)
-                    zv  =  5891.00 + 38.000 * tsn(ji,jj,nla10,jp_tem) + 3.00   * tsn(ji,jj,nla10,jp_sal)                             &
-                         &                                              - 0.3750 * tsn(ji,jj,nla10,jp_tem) * tsn(ji,jj,nla10,jp_tem)
-                    zut =    11.25 -  0.149 * tsn(ji,jj,nla10,jp_tem) - 0.01   * tsn(ji,jj,nla10,jp_sal)
-                    zvt =    38.00 -  0.750 * tsn(ji,jj,nla10,jp_tem)
-                    zw  = (zu + 0.698*zv) * (zu + 0.698*zv)
-                    zdelr(ji,jj) = ztem2 * (1000.*(zut*zv - zvt*zu)/zw)
-                 ELSE
-                    zdelr(ji,jj) = 0._wp
-                 ENDIF
-              END DO
-           END DO
-        ELSE
-           zdelr(:,:) = 0._wp
-        ENDIF
-
-        ! ------------------------------------------------------------- !
-        ! MLD: abs( tn - tn(10m) ) = ztem2                              !
-        ! Top of thermocline: tn = tn(10m) - ztem2                      !
-        ! MLD: rho = rho10m + zrho3                                     !
-        ! pycnocline: rho = rho10m + (dr/dT)(T,S,10m)*(-0.2 degC)       !
-        ! temperature inversion: max( 0, max of tn - tn(10m) )          !
-        ! depth of temperature inversion                                !
-        ! ------------------------------------------------------------- !
-        DO jk = jpkm1, nlb10, -1   ! loop from bottom to nlb10
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 !
-                 zzdep = gdepw_n(ji,jj,jk) * tmask(ji,jj,1)
-                 !
-                 zztmp = tsn(ji,jj,nla10,jp_tem) - tsn(ji,jj,jk,jp_tem)  ! - delta T(10m)
-                 IF( ABS(zztmp) > ztem2 )      zabs2   (ji,jj) = zzdep   ! abs > 0.2
-                 IF(     zztmp  > ztem2 )      ztm2    (ji,jj) = zzdep   ! > 0.2
-                 zztmp = -zztmp                                          ! delta T(10m)
-                 IF( zztmp >  ztinv(ji,jj) ) THEN                        ! temperature inversion
-                    ztinv(ji,jj) = zztmp   ;   zdepinv (ji,jj) = zzdep   ! max value and depth
-                 ENDIF
-
-                 zztmp = rhop(ji,jj,jk) - rhop(ji,jj,nla10)              ! delta rho(10m)
-                 IF( zztmp > zrho3        )    zrho10_3(ji,jj) = zzdep   ! > 0.03
-                 IF( zztmp > zdelr(ji,jj) )    zpycn   (ji,jj) = zzdep   ! > equi. delta T(10m) - 0.2
-                 !
-              END DO
-           END DO
-        END DO
-
-        IF (iom_use("mld_dt02")) CALL iom_put( "mld_dt02", zabs2*tmask(:,:,1)        )   ! MLD abs(delta t) - 0.2
-        IF (iom_use("topthdep")) CALL iom_put( "topthdep", ztm2*tmask(:,:,1)         )   ! T(10) - 0.2
-        IF (iom_use("mldr10_3")) CALL iom_put( "mldr10_3", zrho10_3*tmask(:,:,1)     )   ! MLD delta rho(10m) = 0.03
-        IF (iom_use("pycndep")) CALL iom_put( "pycndep" , zpycn*tmask(:,:,1)        )   ! MLD delta rho equi. delta T(10m) = 0.2
-        IF (iom_use("tinv")) CALL iom_put( "tinv"    , ztinv*tmask(:,:,1)        )   ! max. temp. inv. (t10 ref)
-        IF (iom_use("depti")) CALL iom_put( "depti"   , zdepinv*tmask(:,:,1)      )   ! depth of max. temp. inv. (t10 ref)
-     ENDIF
-
-     IF(iom_use("20d") .OR. iom_use("28d")) THEN
-        ! ----------------------------------- !
-        ! search deepest level above 20C/28C  !
-        ! ----------------------------------- !
-        ik20(:,:) = 1
-        ik28(:,:) = 1
-        DO jk = 1, jpkm1   ! beware temperature is not always decreasing with depth => loop from top to bottom
-           DO jj = 1, jpj
-              DO ji = 1, jpi
-                 zztmp = tsn(ji,jj,jk,jp_tem)
-                 IF( zztmp >= 20. )   ik20(ji,jj) = jk
-                 IF( zztmp >= 28. )   ik28(ji,jj) = jk
-              END DO
-           END DO
-        END DO
-
-        ! --------------------------- !
-        !  Depth of 20C/28C isotherm  !
-        ! --------------------------- !
-        DO jj = 1, jpj
-           DO ji = 1, jpi
-              !
-              zzdep = gdepw_n(ji,jj,mbkt(ji,jj)+1)       ! depth of the oean bottom
-              !
-              iid = ik20(ji,jj)
-              IF( iid /= 1 ) THEN
-                 zztmp =      gdept_n(ji,jj,iid  )   &                     ! linear interpolation
-                      &  + (    gdept_n(ji,jj,iid+1) - gdept_n(ji,jj,iid)                       )   &
-                      &  * ( 20.*tmask(ji,jj,iid+1) - tsn(ji,jj,iid,jp_tem)                       )   &
-                      &  / ( tsn(ji,jj,iid+1,jp_tem) - tsn(ji,jj,iid,jp_tem) + (1.-tmask(ji,jj,1)) )
-                 zhd20(ji,jj) = MIN( zztmp , zzdep) * tmask(ji,jj,1)       ! bound by the ocean depth
-              ELSE
-                 zhd20(ji,jj) = 0._wp
-              ENDIF
-              !
-              iid = ik28(ji,jj)
-              IF( iid /= 1 ) THEN
-                 zztmp =      gdept_n(ji,jj,iid  )   &                     ! linear interpolation
-                      &  + (    gdept_n(ji,jj,iid+1) - gdept_n(ji,jj,iid)                       )   &
-                      &  * ( 28.*tmask(ji,jj,iid+1) -    tsn(ji,jj,iid,jp_tem)                       )   &
-                      &  / (  tsn(ji,jj,iid+1,jp_tem) -    tsn(ji,jj,iid,jp_tem) + (1.-tmask(ji,jj,1)) )
-                 zhd28(ji,jj) = MIN( zztmp , zzdep ) * tmask(ji,jj,1)      ! bound by the ocean depth
-              ELSE
-                 zhd28(ji,jj) = 0._wp
-              ENDIF
-
-           END DO
-        END DO
-        CALL iom_put( "20d", zhd20 )   ! depth of the 20 isotherm
-        CALL iom_put( "28d", zhd28 )   ! depth of the 28 isotherm
-     ENDIF
-
-     ! ----------------------------- !
-     !  Heat content of first 300 m  !
-     ! ----------------------------- !
-     IF (iom_use("hc300")) THEN
-        ! find ilevel with (ilevel+1) the deepest W-level above 300m (we assume we can use e3t_1d to do this search...)
-        ilevel   = 0
-        zthick_0 = 0._wp
-        DO jk = 1, jpkm1
-           zthick_0 = zthick_0 + e3t_1d(jk)
-           IF( zthick_0 < 300. )   ilevel = jk
-        END DO
-        ! surface boundary condition
-        IF( ln_linssh ) THEN   ;   zthick(:,:) = sshn(:,:)   ;   zhtc3(:,:) = tsn(:,:,1,jp_tem) * sshn(:,:) * tmask(:,:,1)
-        ELSE                   ;   zthick(:,:) = 0._wp       ;   zhtc3(:,:) = 0._wp
-        ENDIF
-        ! integration down to ilevel
-        DO jk = 1, ilevel
-           zthick(:,:) = zthick(:,:) + e3t_n(:,:,jk)
-           zhtc3  (:,:) = zhtc3  (:,:) + e3t_n(:,:,jk) * tsn(:,:,jk,jp_tem) * tmask(:,:,jk)
-        END DO
-        ! deepest layer
-        zthick(:,:) = 300. - zthick(:,:)   !   remaining thickness to reach 300m
-        DO jj = 1, jpj
-           DO ji = 1, jpi
-              zhtc3(ji,jj) = zhtc3(ji,jj) + tsn(ji,jj,ilevel+1,jp_tem)                  &
-                   &                      * MIN( e3t_n(ji,jj,ilevel+1), zthick(ji,jj) ) * tmask(ji,jj,ilevel+1)
-           END DO
-        END DO
-        ! from temperature to heat contain
-        zcoef = rau0 * rcp
-        zhtc3(:,:) = zcoef * zhtc3(:,:)
-        CALL iom_put( "hc300", zhtc3*tmask(:,:,1) )      ! first 300m heat content
-     ENDIF
-     !
+ 
+         ! ------------------------------- !
+         !  Depth of 20C/26C/28C isotherm  !
+         ! ------------------------------- !
+         IF( iom_use ('20d') ) THEN  ! depth of the 20 isotherm
+            ztem2 = 20.
+            CALL dia_hth_dep( Kmm, ztem2, hd20 )  
+            CALL iom_put( '20d', hd20 )    
+         ENDIF
+         !
+         IF( iom_use ('26d') ) THEN  ! depth of the 26 isotherm
+            ztem2 = 26.
+            CALL dia_hth_dep( Kmm, ztem2, hd26 )  
+            CALL iom_put( '26d', hd26 )    
+         ENDIF
+         !
+         IF( iom_use ('28d') ) THEN  ! depth of the 28 isotherm
+            ztem2 = 28.
+            CALL dia_hth_dep( Kmm, ztem2, hd28 )  
+            CALL iom_put( '28d', hd28 )    
+         ENDIF
+        
+         ! ----------------------------- !
+         !  Heat content of first 300 m  !
+         ! ----------------------------- !
+         IF( iom_use ('hc300') ) THEN  
+            zzdep = 300.
+            CALL  dia_hth_htc( Kmm, zzdep, ts(:,:,:,jp_tem,Kmm), htc3 )
+            CALL iom_put( 'hc300', rho0_rcp * htc3*tmask(:,:,1) )  ! vertically integrated heat content (J/m2)
+         ENDIF
+         !
+         ! ----------------------------- !
+         !  Heat content of first 700 m  !
+         ! ----------------------------- !
+         IF( iom_use ('hc700') ) THEN  
+            zzdep = 700.
+            CALL  dia_hth_htc( Kmm, zzdep, ts(:,:,:,jp_tem,Kmm), htc7 )
+            CALL iom_put( 'hc700', rho0_rcp * htc7 )  ! vertically integrated heat content (J/m2)
+  
+         ENDIF
+         !
+         ! ----------------------------- !
+         !  Heat content of first 2000 m  !
+         ! ----------------------------- !
+         IF( iom_use ('hc2000') ) THEN  
+            zzdep = 2000.
+            CALL  dia_hth_htc( Kmm, zzdep, ts(:,:,:,jp_tem,Kmm), htc20 )
+            CALL iom_put( 'hc2000', rho0_rcp * htc20 )  ! vertically integrated heat content (J/m2)  
+         ENDIF
+         !
+      ENDIF
+
+      !
+      IF( ln_timing )   CALL timing_stop('dia_hth')
+      !
    END SUBROUTINE dia_hth
 
-
-   SUBROUTINE dia_hth_init
-      !!---------------------------------------------------------------------------
-      !!                  ***  ROUTINE dia_hth_init  ***
-      !!
-      !! ** Purpose: Initialization for ML and thermocline depths
-      !!
-      !! ** Action : If any upper ocean diagnostic required by xml file, set in dia_hth
-      !!---------------------------------------------------------------------------
-       !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'dia_hth_init : heat and salt budgets diagnostics'
-         WRITE(numout,*) '~~~~~~~~~~~~ '
+   SUBROUTINE dia_hth_dep( Kmm, ptem, pdept )
+      !
+      INTEGER , INTENT(in) :: Kmm      ! ocean time level index
+      REAL(wp), INTENT(in) :: ptem
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(out) :: pdept     
+      !
+      INTEGER  :: ji, jj, jk, iid
+      REAL(wp) :: zztmp, zzdep
+      INTEGER, DIMENSION(jpi,jpj) :: iktem
+      
+      ! --------------------------------------- !
+      ! search deepest level above ptem         !
+      ! --------------------------------------- !
+      iktem(:,:) = 1
+      DO_3D_11_11( 1, jpkm1 )
+         zztmp = ts(ji,jj,jk,jp_tem,Kmm)
+         IF( zztmp >= ptem )   iktem(ji,jj) = jk
+      END_3D
+
+      ! ------------------------------- !
+      !  Depth of ptem isotherm         !
+      ! ------------------------------- !
+      DO_2D_11_11
+         !
+         zzdep = gdepw(ji,jj,mbkt(ji,jj)+1,Kmm)       ! depth of the ocean bottom
+         !
+         iid = iktem(ji,jj)
+         IF( iid /= 1 ) THEN 
+             zztmp =     gdept(ji,jj,iid  ,Kmm)   &                     ! linear interpolation
+               &  + (    gdept(ji,jj,iid+1,Kmm) - gdept(ji,jj,iid,Kmm)                       )   &
+               &  * ( 20.*tmask(ji,jj,iid+1) - ts(ji,jj,iid,jp_tem,Kmm)                       )   &
+               &  / ( ts(ji,jj,iid+1,jp_tem,Kmm) - ts(ji,jj,iid,jp_tem,Kmm) + (1.-tmask(ji,jj,1)) )
+            pdept(ji,jj) = MIN( zztmp , zzdep) * tmask(ji,jj,1)       ! bound by the ocean depth
+         ELSE 
+            pdept(ji,jj) = 0._wp
+         ENDIF
+      END_2D
+      !
+   END SUBROUTINE dia_hth_dep
+
+   SUBROUTINE dia_hth_htc( Kmm, pdep, pt, phtc )
+      !
+      INTEGER , INTENT(in) :: Kmm      ! ocean time level index
+      REAL(wp), INTENT(in) :: pdep     ! depth over the heat content
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: pt   
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: phtc  
+      !
+      INTEGER  :: ji, jj, jk, ik
+      REAL(wp), DIMENSION(jpi,jpj) :: zthick
+      INTEGER , DIMENSION(jpi,jpj) :: ilevel
+
+
+      ! surface boundary condition
+      
+      IF( .NOT. ln_linssh ) THEN   ;   zthick(:,:) = 0._wp       ;   phtc(:,:) = 0._wp                                   
+      ELSE                         ;   zthick(:,:) = ssh(:,:,Kmm)   ;   phtc(:,:) = pt(:,:,1) * ssh(:,:,Kmm) * tmask(:,:,1)   
       ENDIF
-      ll_diahth = iom_use("mlddzt") .OR. iom_use("mldr0_3") .OR. iom_use("mldr0_1") .OR.  &
-           & iom_use("mld_dt02") .OR. iom_use("topthdep") .OR. iom_use("mldr10_3") .OR.  &
-           & iom_use("pycndep") .OR. iom_use("tinv") .OR. iom_use("depti").OR. &
-           & iom_use("20d") .OR. iom_use("28d") .OR. iom_use("hc300")
-      IF(lwp) THEN
-         WRITE(numout,*) '   output upper ocean diagnostics (T) or not (F)       ll_diahth = ', ll_diahth
-      ENDIF
-      !
-   END SUBROUTINE dia_hth_init
+      !
+      ilevel(:,:) = 1
+      DO_3D_11_11( 2, jpkm1 )
+         IF( ( gdept(ji,jj,jk,Kmm) < pdep ) .AND. ( tmask(ji,jj,jk) == 1 ) ) THEN
+             ilevel(ji,jj) = jk
+             zthick(ji,jj) = zthick(ji,jj) + e3t(ji,jj,jk,Kmm)
+             phtc  (ji,jj) = phtc  (ji,jj) + e3t(ji,jj,jk,Kmm) * pt(ji,jj,jk)
+         ENDIF
+      END_3D
+      !
+      DO_2D_11_11
+         ik = ilevel(ji,jj)
+         zthick(ji,jj) = pdep - zthick(ji,jj)   !   remaining thickness to reach depht pdep
+         phtc(ji,jj)   = phtc(ji,jj) + pt(ji,jj,ik+1) * MIN( e3t(ji,jj,ik+1,Kmm), zthick(ji,jj) ) &
+                                                       * tmask(ji,jj,ik+1)
+      END_2D
+      !
+      !
+   END SUBROUTINE dia_hth_htc
+
+   !!======================================================================
 END MODULE diahth
